#include "Sample.h"

void CDxFontTestStart::Init()
{
	AppendObject(new CDxFont(), -1, "font", true);

	CMoveFont *movefont;
	for(int x = 0; x < 640; x += 30){
		movefont = new CMoveFont();
		movefont->SetStartState(x, rand() % (480 - 16), rand() % 4 + 1);

		AppendObject(movefont, 1000 + x, true);
	}

	RemoveObject(this);
}

void CMoveFont::SetStartState(int pos_x, int pos_y, int speed)
{
	x = pos_x;
	y = pos_y;
	m = speed;
}

void CMoveFont::Init()
{
	pFont = (CDxFont*)FindObject("font");
}

void CMoveFont::Exec()
{
	if(pFont){
		if(y < 0 || y > 480 - 16) m = -m;
		y += m;

		pFont->Draw(_T("Text"), x, y);
	}
}



void CTextureTestStart::Init()
{
	CTextureTest *obj = new CTextureTest();
	obj->SetStartPosition(320 - 16, 240 - 16);
	AppendObject(obj, 1000, true);

	RemoveObject(this);
}

void CTextureTest::SetStartPosition(float sx, float sy)
{
	x = sx;
	y = sy;
}

void CTextureTest::Init()
{
	tex.Load(_T("soccerball.png"));
	tex.SetCenterPosition(MiddleCenter);

	mx = my = 2.0f;
}

void CTextureTest::Exec()
{
	x += mx;
	if(x < 0){
		x = 0;
		mx = -mx;
	}else if(x > 640){
		x = 640;
		mx = -mx;
	}

	y += my;
	if(y < 0){
		y = 0;
		my = -my;
	}else if(y > 480){
		y = 480;
		my = -my;
	}

	tex.Draw(x, y);
}

void CAnimationTest::Init()
{
	tex.Load(_T("anime.png"));
	tex.SetSpriteSize(128, 128);

	count = frame = 0;
}

void CAnimationTest::Exec()
{
	tex.Draw(320, 240);
	
	if(++count >= 12){
		count = 0;
		if(++frame >= 8) frame = 0;
		tex.SetFrame(frame);
	}
}
